/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractAjaxStatus;

/**
 *  @author Nick Belaevski


 **/
@Generated({"RichFaces CDK", "4.0.0-SNAPSHOT"})
public class UIStatus extends AbstractAjaxStatus
    implements ClientBehaviorHolder
    {

    public static final String COMPONENT_TYPE="org.richfaces.Status";

    public static final String COMPONENT_FAMILY="org.richfaces.Status";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UIStatus() {
        super();
        setRendererType("org.richfaces.StatusRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "stop",
        "start",
        "error",
        "success"

        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }

    protected static enum Properties {
        onerror,
        onstart,
        onstop,
        onsuccess

    }


 
    public String getOnerror() {
        return (String) getStateHelper().eval(Properties.onerror);
    }
    
    public void setOnerror(String onerror) {
        getStateHelper().put(Properties.onerror, onerror);
    }

 
    public String getOnstart() {
        return (String) getStateHelper().eval(Properties.onstart);
    }
    
    public void setOnstart(String onstart) {
        getStateHelper().put(Properties.onstart, onstart);
    }

 
    public String getOnstop() {
        return (String) getStateHelper().eval(Properties.onstop);
    }
    
    public void setOnstop(String onstop) {
        getStateHelper().put(Properties.onstop, onstop);
    }

 
    public String getOnsuccess() {
        return (String) getStateHelper().eval(Properties.onsuccess);
    }
    
    public void setOnsuccess(String onsuccess) {
        getStateHelper().put(Properties.onsuccess, onsuccess);
    }

}